﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Steema.TeeChart;
using Steema.TeeChart.Styles;
using Steema.TeeChart.Tools;

namespace TrendControl
{
  public partial class Form1 : Form
  {
    public Form1()
    {
      InitializeComponent();
      TeeChart.Legend.Visible = false;
      TeeChart.Zoom.Allow = false;
      double _StackSize = 10;
      double _StartPos = 0;
      double _EndPos = _StackSize;
      for (int i = 0; i < 10; i++)
      {
        FastLine _FastLine = new FastLine();
        _FastLine.FillSampleValues(1000);
        TeeChart.Series.Add(_FastLine);
        Axis _Axis = new Axis(TeeChart.Chart);
        TeeChart.Axes.Custom.Add(_Axis);
        _Axis.AxisPen.Color = _FastLine.Color;
        _FastLine.LinePen.Width = 3;
        _Axis.AxisPen.Width = 20;
        _Axis.StartPosition = _StartPos;
        _Axis.EndPosition = _EndPos;
        _StartPos = _EndPos;
        _EndPos += _StackSize;
        _FastLine.CustomVertAxis = _Axis;

      }
    }
    private int ZoomX, ZoomY;
    Boolean bHaveMouse;
    Point ptOriginal = new Point();
    Point ptLast = new Point();
    private void TeeChart_MouseDown(object sender, MouseEventArgs e)
    {
      if (e.Button == MouseButtons.Left)
      {
        //ZoomRect = new Rectangle(e.X, e.Y, 0, 0);
        ZoomX = e.X;
        ZoomY = e.Y;
        // Make a note that we "have the mouse".
        bHaveMouse = true;
        // Store the "starting point" for this rubber-band rectangle.
        ptOriginal.X = e.X;
        ptOriginal.Y = e.Y;
        // Special value lets us know that no previous
        // rectangle needs to be erased.
        ptLast.X = -1;
        ptLast.Y = -1;
      }
    }

    private void TeeChart_MouseMove(object sender, MouseEventArgs e)
    {
      if (e.Button == MouseButtons.Left)
      {
        Point ptCurrent = new Point(e.X, e.Y);
        // If we "have the mouse", then we draw our lines.
        if (bHaveMouse)
        {
          // If we have drawn previously, draw again in
          // that spot to remove the lines.
          if (ptLast.X != -1)
          {
            DrawZoomRectangle(ptOriginal, ptLast);
          }
          // Update last point.
          ptLast = ptCurrent;
          // Draw new lines.
          DrawZoomRectangle(ptOriginal, ptCurrent);
        }

      }
    }

    private void TeeChart_MouseUp(object sender, MouseEventArgs e)
    {
      if (e.Button == MouseButtons.Left)
      {
        //Draw the reversible rectangle
        // Set internal flag to know we no longer "have the mouse".
        bHaveMouse = false;
        // If we have drawn previously, draw again in that spot
        // to remove the lines.
        if (ptLast.X != -1)
        {
          Point ptCurrent = new Point(e.X, e.Y);
          DrawZoomRectangle(ptOriginal, ptLast);
        }
        // Set flags to know that there is no "previous" line to reverse.
        ptLast.X = -1;
        ptLast.Y = -1;
        ptOriginal.X = -1;
        ptOriginal.Y = -1;

        if (e.X == ZoomX && e.Y == ZoomY) return;

        foreach (Steema.TeeChart.Axis _Axis in TeeChart.Axes.Custom)
        {
          _Axis.SetMinMax(_Axis.CalcPosPoint(e.Y), _Axis.CalcPosPoint(ZoomY));
        }


        if (e.X > ZoomX)
          TeeChart.Axes.Bottom.SetMinMax(TeeChart.Axes.Bottom.CalcPosPoint(ZoomX), TeeChart.Axes.Bottom.CalcPosPoint(e.X));
        else
          TeeChart.Axes.Bottom.SetMinMax(TeeChart.Axes.Bottom.CalcPosPoint(e.X), TeeChart.Axes.Bottom.CalcPosPoint(ZoomX));
      }
      TeeChart.Draw();
    }

    private void DrawZoomRectangle(Point p1, Point p2)
    {
      Rectangle rc = new Rectangle();

      // Convert the points to screen coordinates.
      p1 = PointToScreen(p1);
      p2 = PointToScreen(p2);
      // Normalize the rectangle.
      if (p1.X < p2.X)
      {
        rc.X = p1.X;
        rc.Width = p2.X - p1.X;
      }
      else
      {
        rc.X = p2.X;
        rc.Width = p1.X - p2.X;
      }
      if (p1.Y < p2.Y)
      {
        rc.Y = p1.Y;
        rc.Height = p2.Y - p1.Y;
      }
      else
      {
        rc.Y = p2.Y;
        rc.Height = p1.Y - p2.Y;
      }
      // Draw the reversible frame.
      ControlPaint.DrawReversibleFrame(rc, Color.DarkBlue, FrameStyle.Dashed);
    }

    private void button1_Click(object sender, EventArgs e)
    {
      TeeChart.Axes.Bottom.Automatic = true;
      ReDraw();
    }
    private void ReDraw()
    {
      TeeChart.Series.Clear();
      TeeChart.Axes.Custom.Clear();
      double _StackSize = 10;
      double _StartPos = 0;
      double _EndPos = _StackSize;
      for (int i = 0; i < 10; i++)
      {
        FastLine _FastLine = new FastLine();
        _FastLine.FillSampleValues(1000);
        TeeChart.Series.Add(_FastLine);
        Axis _Axis = new Axis(TeeChart.Chart);
        TeeChart.Axes.Custom.Add(_Axis);
        _Axis.AxisPen.Color = _FastLine.Color;
        _FastLine.LinePen.Width = 3;
        _Axis.AxisPen.Width = 20;
        _Axis.StartPosition = _StartPos;
        _Axis.EndPosition = _EndPos;
        _StartPos = _EndPos;
        _EndPos += _StackSize;
        _FastLine.CustomVertAxis = _Axis;

      }
    }
  }
}
